jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # |
| 3 | # Copyright (C) 2007 The Android Open Source Project |
| 4 | # |
| 5 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 6 | # you may not use this file except in compliance with the License. |
| 7 | # You may obtain a copy of the License at |
| 8 | # |
| 9 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 10 | # |
| 11 | # Unless required by applicable law or agreed to in writing, software |
| 12 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 13 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 14 | # See the License for the specific language governing permissions and |
| 15 | # limitations under the License. |
| 16 | |
| 17 | # Set up prog to be the path of this script, including following symlinks, |
| 18 | # and set up progdir to be the fully-qualified pathname of its directory. |
| 19 | prog="$0" |
Andreas Gampe | deb48a0 | 2014-10-22 00:44:35 -0700 | [diff] [blame] | 20 | args="$@" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 21 | while [ -h "${prog}" ]; do |
| 22 | newProg=`/bin/ls -ld "${prog}"` |
| 23 | newProg=`expr "${newProg}" : ".* -> \(.*\)$"` |
| 24 | if expr "x${newProg}" : 'x/' >/dev/null; then |
| 25 | prog="${newProg}" |
| 26 | else |
| 27 | progdir=`dirname "${prog}"` |
| 28 | prog="${progdir}/${newProg}" |
| 29 | fi |
| 30 | done |
| 31 | oldwd=`pwd` |
| 32 | progdir=`dirname "${prog}"` |
| 33 | cd "${progdir}" |
| 34 | progdir=`pwd` |
| 35 | prog="${progdir}"/`basename "${prog}"` |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 36 | test_dir="test-$$" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 37 | if [ -z "$TMPDIR" ]; then |
| 38 | tmp_dir="/tmp/$USER/${test_dir}" |
| 39 | else |
Andreas Gampe | 34a8a0f | 2016-07-20 21:09:29 -0700 | [diff] [blame] | 40 | tmp_dir="${TMPDIR}/${test_dir}" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 41 | fi |
David Brazdil | 2c27f2c | 2015-05-12 18:06:38 +0100 | [diff] [blame] | 42 | checker="${progdir}/../tools/checker/checker.py" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 43 | export JAVA="java" |
Alex Light | ea1e770 | 2016-07-11 13:39:55 -0700 | [diff] [blame] | 44 | export JAVAC="javac -g -Xlint:-options" |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 45 | export RUN="${progdir}/etc/run-test-jar" |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 46 | export DEX_LOCATION=/data/run-test/${test_dir} |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 47 | export NEED_DEX="true" |
Nicolas Geoffray | 1c5b6da | 2016-03-16 10:55:57 +0000 | [diff] [blame] | 48 | export USE_JACK="true" |
Igor Murashkin | 2a33775 | 2017-06-16 14:34:40 +0000 | [diff] [blame^] | 49 | export USE_DESUGAR="true" |
Ben Gruver | 14fc9db | 2017-04-28 15:30:49 -0700 | [diff] [blame] | 50 | export SMALI_ARGS="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 51 | |
Tsu Chiang Chuang | 4407e61 | 2012-07-19 16:13:43 -0700 | [diff] [blame] | 52 | # If dx was not set by the environment variable, assume it is in the path. |
| 53 | if [ -z "$DX" ]; then |
| 54 | export DX="dx" |
| 55 | fi |
| 56 | |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 57 | # If jasmin was not set by the environment variable, assume it is in the path. |
| 58 | if [ -z "$JASMIN" ]; then |
| 59 | export JASMIN="jasmin" |
| 60 | fi |
| 61 | |
Andreas Gampe | 8fda9f2 | 2014-10-03 16:15:37 -0700 | [diff] [blame] | 62 | # If smali was not set by the environment variable, assume it is in the path. |
| 63 | if [ -z "$SMALI" ]; then |
| 64 | export SMALI="smali" |
| 65 | fi |
| 66 | |
| 67 | # If dexmerger was not set by the environment variable, assume it is in the path. |
| 68 | if [ -z "$DXMERGER" ]; then |
| 69 | export DXMERGER="dexmerger" |
| 70 | fi |
| 71 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 72 | # If jack was not set by the environment variable, assume it is in the path. |
| 73 | if [ -z "$JACK" ]; then |
| 74 | export JACK="jack" |
| 75 | fi |
| 76 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 77 | # ANDROID_BUILD_TOP is not set in a build environment. |
| 78 | if [ -z "$ANDROID_BUILD_TOP" ]; then |
| 79 | export ANDROID_BUILD_TOP=$oldwd |
| 80 | fi |
| 81 | |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 82 | # ANDROID_HOST_OUT is not set in a build environment. |
| 83 | if [ -z "$ANDROID_HOST_OUT" ]; then |
Dan Willemsen | f325e01 | 2017-03-03 12:35:30 -0800 | [diff] [blame] | 84 | export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out}/host/linux-x86 |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 85 | fi |
| 86 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 87 | # If JACK_CLASSPATH is not set, assume it only contains core-libart. |
| 88 | if [ -z "$JACK_CLASSPATH" ]; then |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 89 | export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 90 | fi |
| 91 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 92 | export JACK="$JACK -g -cp $JACK_CLASSPATH" |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 93 | |
Igor Murashkin | 271a0f8 | 2017-02-14 21:14:17 +0000 | [diff] [blame] | 94 | # Zipalign is not on the PATH in some configs, auto-detect it. |
| 95 | if [ -z "$ZIPALIGN" ]; then |
| 96 | if which zipalign >/dev/null; then |
| 97 | ZIPALIGN="zipalign"; |
| 98 | else |
| 99 | # TODO: Add a dependency for zipalign in Android.run-test.mk |
| 100 | # once it doesn't depend on libandroidfw (b/35246701) |
| 101 | case "$OSTYPE" in |
| 102 | darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;; |
| 103 | linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;; |
| 104 | *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;; |
| 105 | esac |
| 106 | fi |
| 107 | fi |
| 108 | export ZIPALIGN |
| 109 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 110 | info="info.txt" |
| 111 | build="build" |
| 112 | run="run" |
| 113 | expected="expected.txt" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 114 | check_cmd="check" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 115 | output="output.txt" |
| 116 | build_output="build-output.txt" |
David Brazdil | 24128c6 | 2015-05-21 12:06:13 +0100 | [diff] [blame] | 117 | cfg_output="graph.cfg" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 118 | strace_output="strace-output.txt" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 119 | lib="libartd.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 120 | testlib="arttestd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 121 | run_args="--quiet" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 122 | build_args="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 123 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 124 | quiet="no" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 125 | debuggable="no" |
Alex Light | 9d72253 | 2014-07-22 18:07:12 -0700 | [diff] [blame] | 126 | prebuild_mode="yes" |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 127 | target_mode="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 128 | dev_mode="no" |
| 129 | update_mode="no" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 130 | debug_mode="no" |
Nicolas Geoffray | 94e25db | 2017-01-27 14:54:28 +0000 | [diff] [blame] | 131 | relocate="no" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 132 | runtime="art" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 133 | usage="no" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 134 | build_only="no" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 135 | suffix64="" |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 136 | trace="false" |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 137 | trace_stream="false" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 138 | basic_verify="false" |
| 139 | gc_verify="false" |
| 140 | gc_stress="false" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 141 | jvmti_trace_stress="false" |
| 142 | jvmti_redefine_stress="false" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 143 | strace="false" |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 144 | always_clean="no" |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 145 | never_clean="no" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 146 | have_dex2oat="yes" |
| 147 | have_patchoat="yes" |
| 148 | have_image="yes" |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 149 | multi_image_suffix="" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 150 | android_root="/system" |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 151 | bisection_search="no" |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 152 | suspend_timeout="500000" |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 153 | # By default we will use optimizing. |
| 154 | image_args="" |
Nicolas Geoffray | b76bc78 | 2016-09-14 12:33:34 +0000 | [diff] [blame] | 155 | image_suffix="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 156 | |
| 157 | while true; do |
| 158 | if [ "x$1" = "x--host" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 159 | target_mode="no" |
TDYa127 | b92bcab | 2012-04-08 00:09:51 -0700 | [diff] [blame] | 160 | DEX_LOCATION=$tmp_dir |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 161 | run_args="${run_args} --host" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 162 | shift |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 163 | elif [ "x$1" = "x--quiet" ]; then |
| 164 | quiet="yes" |
| 165 | shift |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 166 | elif [ "x$1" = "x--use-java-home" ]; then |
| 167 | if [ -n "${JAVA_HOME}" ]; then |
| 168 | export JAVA="${JAVA_HOME}/bin/java" |
| 169 | export JAVAC="${JAVA_HOME}/bin/javac -g" |
| 170 | else |
| 171 | echo "Passed --use-java-home without JAVA_HOME variable set!" |
| 172 | usage="yes" |
| 173 | fi |
| 174 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 175 | elif [ "x$1" = "x--jvm" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 176 | target_mode="no" |
Alex Light | 2c7aaeb | 2017-01-27 14:08:17 -0800 | [diff] [blame] | 177 | DEX_LOCATION="$tmp_dir" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 178 | runtime="jvm" |
Alex Light | bc90d0f | 2016-05-09 16:21:09 -0700 | [diff] [blame] | 179 | image_args="" |
Brian Carlstrom | 01afdba | 2014-10-03 10:28:47 -0700 | [diff] [blame] | 180 | prebuild_mode="no" |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 181 | NEED_DEX="false" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 182 | USE_JACK="false" |
Nicolas Geoffray | 288a4a2 | 2014-10-07 11:02:40 +0100 | [diff] [blame] | 183 | run_args="${run_args} --jvm" |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 184 | build_args="${build_args} --jvm" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 185 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 186 | elif [ "x$1" = "x-O" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 187 | lib="libart.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 188 | testlib="arttest" |
Alex Light | faf90b6 | 2016-08-12 14:43:48 -0700 | [diff] [blame] | 189 | run_args="${run_args} -O" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 190 | shift |
| 191 | elif [ "x$1" = "x--dalvik" ]; then |
| 192 | lib="libdvm.so" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 193 | runtime="dalvik" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 194 | shift |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 195 | elif [ "x$1" = "x--no-dex2oat" ]; then |
| 196 | have_dex2oat="no" |
| 197 | shift |
| 198 | elif [ "x$1" = "x--no-patchoat" ]; then |
| 199 | have_patchoat="no" |
| 200 | shift |
| 201 | elif [ "x$1" = "x--no-image" ]; then |
| 202 | have_image="no" |
| 203 | shift |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 204 | elif [ "x$1" = "x--multi-image" ]; then |
| 205 | multi_image_suffix="-multi" |
| 206 | shift |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 207 | elif [ "x$1" = "x--pic-test" ]; then |
| 208 | run_args="${run_args} --pic-test" |
| 209 | shift |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 210 | elif [ "x$1" = "x--relocate" ]; then |
| 211 | relocate="yes" |
| 212 | shift |
| 213 | elif [ "x$1" = "x--no-relocate" ]; then |
| 214 | relocate="no" |
| 215 | shift |
| 216 | elif [ "x$1" = "x--prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 217 | run_args="${run_args} --prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 218 | prebuild_mode="yes" |
| 219 | shift; |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 220 | elif [ "x$1" = "x--strip-dex" ]; then |
| 221 | run_args="${run_args} --strip-dex" |
| 222 | shift; |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 223 | elif [ "x$1" = "x--debuggable" ]; then |
| 224 | run_args="${run_args} -Xcompiler-option --debuggable" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 225 | debuggable="yes" |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 226 | shift; |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 227 | elif [ "x$1" = "x--no-prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 228 | run_args="${run_args} --no-prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 229 | prebuild_mode="no" |
| 230 | shift; |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 231 | elif [ "x$1" = "x--gcverify" ]; then |
| 232 | basic_verify="true" |
| 233 | gc_verify="true" |
| 234 | shift |
| 235 | elif [ "x$1" = "x--gcstress" ]; then |
| 236 | basic_verify="true" |
| 237 | gc_stress="true" |
| 238 | shift |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 239 | elif [ "x$1" = "x--jvmti-redefine-stress" ]; then |
| 240 | jvmti_redefine_stress="true" |
| 241 | shift |
| 242 | elif [ "x$1" = "x--jvmti-trace-stress" ]; then |
| 243 | jvmti_trace_stress="true" |
Alex Light | 8f2c6d4 | 2017-04-10 16:27:35 -0700 | [diff] [blame] | 244 | shift |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 245 | elif [ "x$1" = "x--suspend-timeout" ]; then |
| 246 | shift |
| 247 | suspend_timeout="$1" |
| 248 | shift |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 249 | elif [ "x$1" = "x--image" ]; then |
| 250 | shift |
| 251 | image="$1" |
| 252 | run_args="${run_args} --image $image" |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 253 | shift |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 254 | elif [ "x$1" = "x-Xcompiler-option" ]; then |
| 255 | shift |
| 256 | option="$1" |
| 257 | run_args="${run_args} -Xcompiler-option $option" |
| 258 | shift |
Orion Hodson | e1fb77f | 2017-02-27 13:57:18 +0000 | [diff] [blame] | 259 | elif [ "x$1" = "x--build-option" ]; then |
| 260 | shift |
| 261 | option="$1" |
| 262 | build_args="${build_args} $option" |
| 263 | shift |
Mathieu Chartier | 769a5ad | 2014-05-18 15:30:10 -0700 | [diff] [blame] | 264 | elif [ "x$1" = "x--runtime-option" ]; then |
| 265 | shift |
| 266 | option="$1" |
| 267 | run_args="${run_args} --runtime-option $option" |
| 268 | shift |
Mathieu Chartier | c0a8a80 | 2014-10-17 15:58:01 -0700 | [diff] [blame] | 269 | elif [ "x$1" = "x--gdb-arg" ]; then |
| 270 | shift |
| 271 | gdb_arg="$1" |
| 272 | run_args="${run_args} --gdb-arg $gdb_arg" |
| 273 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 274 | elif [ "x$1" = "x--debug" ]; then |
| 275 | run_args="${run_args} --debug" |
| 276 | shift |
| 277 | elif [ "x$1" = "x--gdb" ]; then |
| 278 | run_args="${run_args} --gdb" |
| 279 | dev_mode="yes" |
| 280 | shift |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 281 | elif [ "x$1" = "x--strace" ]; then |
| 282 | strace="yes" |
Mathieu Chartier | 2576be2 | 2016-05-24 10:24:53 -0700 | [diff] [blame] | 283 | run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 284 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 285 | elif [ "x$1" = "x--zygote" ]; then |
| 286 | run_args="${run_args} --zygote" |
| 287 | shift |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 288 | elif [ "x$1" = "x--interpreter" ]; then |
Nicolas Geoffray | 4650c93 | 2016-05-10 09:13:13 +0000 | [diff] [blame] | 289 | run_args="${run_args} --interpreter" |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 290 | image_suffix="-interpreter" |
| 291 | shift |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 292 | elif [ "x$1" = "x--jit" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 293 | image_args="--jit" |
Nicolas Geoffray | b76bc78 | 2016-09-14 12:33:34 +0000 | [diff] [blame] | 294 | image_suffix="-interpreter" |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 295 | shift |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 296 | elif [ "x$1" = "x--optimizing" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 297 | image_args="-Xcompiler-option --compiler-backend=Optimizing" |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 298 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 299 | elif [ "x$1" = "x--no-verify" ]; then |
Richard Uhler | f4b3487 | 2016-04-13 11:03:46 -0700 | [diff] [blame] | 300 | run_args="${run_args} --no-verify" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 301 | shift |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 302 | elif [ "x$1" = "x--verify-soft-fail" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 303 | image_args="--verify-soft-fail" |
Andreas Gampe | 825570c | 2015-07-26 10:26:03 -0700 | [diff] [blame] | 304 | image_suffix="-interp-ac" |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 305 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 306 | elif [ "x$1" = "x--no-optimize" ]; then |
| 307 | run_args="${run_args} --no-optimize" |
| 308 | shift |
| 309 | elif [ "x$1" = "x--no-precise" ]; then |
| 310 | run_args="${run_args} --no-precise" |
| 311 | shift |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 312 | elif [ "x$1" = "x--invoke-with" ]; then |
| 313 | shift |
| 314 | what="$1" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 315 | if [ "x$what" = "x" ]; then |
| 316 | echo "$0 missing argument to --invoke-with" 1>&2 |
| 317 | usage="yes" |
| 318 | break |
| 319 | fi |
Ian Rogers | 0e03367 | 2013-04-19 10:22:46 -0700 | [diff] [blame] | 320 | run_args="${run_args} --invoke-with ${what}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 321 | shift |
| 322 | elif [ "x$1" = "x--dev" ]; then |
| 323 | run_args="${run_args} --dev" |
| 324 | dev_mode="yes" |
| 325 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 326 | elif [ "x$1" = "x--build-only" ]; then |
| 327 | build_only="yes" |
| 328 | shift |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 329 | elif [ "x$1" = "x--build-with-javac-dx" ]; then |
| 330 | USE_JACK="false" |
| 331 | shift |
| 332 | elif [ "x$1" = "x--build-with-jack" ]; then |
| 333 | USE_JACK="true" |
| 334 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 335 | elif [ "x$1" = "x--output-path" ]; then |
| 336 | shift |
| 337 | tmp_dir=$1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 338 | if [ "x$tmp_dir" = "x" ]; then |
| 339 | echo "$0 missing argument to --output-path" 1>&2 |
| 340 | usage="yes" |
| 341 | break |
| 342 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 343 | shift |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 344 | elif [ "x$1" = "x--android-root" ]; then |
| 345 | shift |
| 346 | if [ "x$1" = "x" ]; then |
| 347 | echo "$0 missing argument to --android-root" 1>&2 |
| 348 | usage="yes" |
| 349 | break |
| 350 | fi |
| 351 | android_root="$1" |
| 352 | run_args="${run_args} --android-root $1" |
| 353 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 354 | elif [ "x$1" = "x--update" ]; then |
| 355 | update_mode="yes" |
| 356 | shift |
| 357 | elif [ "x$1" = "x--help" ]; then |
| 358 | usage="yes" |
| 359 | shift |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 360 | elif [ "x$1" = "x--64" ]; then |
| 361 | run_args="${run_args} --64" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 362 | suffix64="64" |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 363 | shift |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 364 | elif [ "x$1" = "x--trace" ]; then |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 365 | trace="true" |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 366 | shift |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 367 | elif [ "x$1" = "x--stream" ]; then |
| 368 | trace_stream="true" |
| 369 | shift |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 370 | elif [ "x$1" = "x--always-clean" ]; then |
| 371 | always_clean="yes" |
| 372 | shift |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 373 | elif [ "x$1" = "x--never-clean" ]; then |
| 374 | never_clean="yes" |
| 375 | shift |
Andreas Gampe | e21dc3d | 2014-12-08 16:59:43 -0800 | [diff] [blame] | 376 | elif [ "x$1" = "x--dex2oat-swap" ]; then |
| 377 | run_args="${run_args} --dex2oat-swap" |
| 378 | shift |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 379 | elif [ "x$1" = "x--instruction-set-features" ]; then |
| 380 | shift |
| 381 | run_args="${run_args} --instruction-set-features $1" |
| 382 | shift |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 383 | elif [ "x$1" = "x--bisection-search" ]; then |
| 384 | bisection_search="yes" |
| 385 | shift |
Nicolas Geoffray | b0bbe8e | 2016-11-19 10:42:37 +0000 | [diff] [blame] | 386 | elif [ "x$1" = "x--vdex" ]; then |
| 387 | run_args="${run_args} --vdex" |
| 388 | shift |
Nicolas Geoffray | 7498105 | 2017-01-16 17:54:09 +0000 | [diff] [blame] | 389 | elif [ "x$1" = "x--vdex-filter" ]; then |
| 390 | shift |
| 391 | filter=$1 |
| 392 | run_args="${run_args} --vdex-filter $filter" |
| 393 | shift |
Jeff Hao | 002b931 | 2017-03-27 16:23:08 -0700 | [diff] [blame] | 394 | elif [ "x$1" = "x--random-profile" ]; then |
| 395 | run_args="${run_args} --random-profile" |
| 396 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 397 | elif expr "x$1" : "x--" >/dev/null 2>&1; then |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 398 | echo "unknown $0 option: $1" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 399 | usage="yes" |
| 400 | break |
| 401 | else |
| 402 | break |
| 403 | fi |
| 404 | done |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 405 | |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 406 | run_args="${run_args} ${image_args}" |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 407 | # Allocate file descriptor real_stderr and redirect it to the shell's error |
| 408 | # output (fd 2). |
| 409 | if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then |
| 410 | exec {real_stderr}>&2 |
| 411 | else |
| 412 | # In bash before version 4.1 we need to do a manual search for free file |
| 413 | # descriptors. |
| 414 | FD=3 |
| 415 | while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done |
| 416 | real_stderr=$FD |
| 417 | eval "exec ${real_stderr}>&2" |
| 418 | fi |
| 419 | if [ "$quiet" = "yes" ]; then |
| 420 | # Force the default standard output and error to go to /dev/null so we will |
| 421 | # not print them. |
| 422 | exec 1>/dev/null |
| 423 | exec 2>/dev/null |
| 424 | fi |
| 425 | |
| 426 | function err_echo() { |
| 427 | echo "$@" 1>&${real_stderr} |
| 428 | } |
| 429 | |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 430 | # tmp_dir may be relative, resolve. |
| 431 | # |
| 432 | # Cannot use realpath, as it does not exist on Mac. |
| 433 | # Cannot us a simple "cd", as the path might not be created yet. |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 434 | # Cannot use readlink -m, as it does not exist on Mac. |
| 435 | # Fallback to nuclear option: |
Andreas Gampe | 907b699 | 2014-08-18 22:26:49 -0700 | [diff] [blame] | 436 | noncanonical_tmp_dir=$tmp_dir |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 437 | tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`" |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 438 | mkdir -p $tmp_dir |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 439 | |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 440 | # Add thread suspend timeout flag |
Narayan Kamath | f86c393 | 2017-01-24 17:40:47 +0000 | [diff] [blame] | 441 | if [ ! "$runtime" = "jvm" ]; then |
| 442 | run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout" |
| 443 | fi |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 444 | |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 445 | if [ "$basic_verify" = "true" ]; then |
Hiroshi Yamauchi | 312baf1 | 2015-01-12 12:11:05 -0800 | [diff] [blame] | 446 | # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests. |
| 447 | run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 448 | fi |
| 449 | if [ "$gc_verify" = "true" ]; then |
| 450 | run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc" |
| 451 | fi |
| 452 | if [ "$gc_stress" = "true" ]; then |
Mathieu Chartier | d9eb284 | 2016-08-12 16:11:24 -0700 | [diff] [blame] | 453 | run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 454 | fi |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 455 | if [ "$jvmti_redefine_stress" = "true" ]; then |
| 456 | run_args="${run_args} --no-app-image --jvmti-redefine-stress" |
| 457 | fi |
| 458 | if [ "$jvmti_trace_stress" = "true" ]; then |
| 459 | run_args="${run_args} --no-app-image --jvmti-trace-stress" |
Alex Light | 8f2c6d4 | 2017-04-10 16:27:35 -0700 | [diff] [blame] | 460 | fi |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 461 | if [ "$trace" = "true" ]; then |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 462 | run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000" |
| 463 | if [ "$trace_stream" = "true" ]; then |
| 464 | # Streaming mode uses the file size as the buffer size. So output gets really large. Drop |
| 465 | # the ability to analyze the file and just write to /dev/null. |
| 466 | run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null" |
| 467 | # Enable streaming mode. |
| 468 | run_args="${run_args} --runtime-option -Xmethod-trace-stream" |
| 469 | else |
| 470 | run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin" |
| 471 | fi |
| 472 | elif [ "$trace_stream" = "true" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 473 | err_echo "Cannot use --stream without --trace." |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 474 | exit 1 |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 475 | fi |
| 476 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 477 | # Most interesting target architecture variables are Makefile variables, not environment variables. |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 478 | # Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name. |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 479 | function guess_target_arch_name() { |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 480 | grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'` |
Andreas Gampe | 1a5c406 | 2015-01-15 12:10:47 -0800 | [diff] [blame] | 481 | grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'` |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 482 | if [ "x${suffix64}" = "x64" ]; then |
| 483 | target_arch_name=${grep64bit} |
| 484 | else |
| 485 | target_arch_name=${grep32bit} |
| 486 | fi |
| 487 | } |
| 488 | |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 489 | function guess_host_arch_name() { |
| 490 | if [ "x${suffix64}" = "x64" ]; then |
| 491 | host_arch_name="x86_64" |
| 492 | else |
| 493 | host_arch_name="x86" |
| 494 | fi |
| 495 | } |
| 496 | |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 497 | if [ "$target_mode" = "no" ]; then |
| 498 | if [ "$runtime" = "jvm" ]; then |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 499 | if [ "$prebuild_mode" = "yes" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 500 | err_echo "--prebuild with --jvm is unsupported" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 501 | exit 1; |
| 502 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 503 | fi |
| 504 | fi |
| 505 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 506 | if [ "$have_patchoat" = "no" ]; then |
| 507 | run_args="${run_args} --no-patchoat" |
| 508 | fi |
| 509 | |
| 510 | if [ "$have_dex2oat" = "no" ]; then |
| 511 | run_args="${run_args} --no-dex2oat" |
| 512 | fi |
| 513 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 514 | if [ ! "$runtime" = "jvm" ]; then |
| 515 | run_args="${run_args} --lib $lib" |
| 516 | fi |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 517 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 518 | if [ "$runtime" = "dalvik" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 519 | if [ "$target_mode" = "no" ]; then |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 520 | framework="${ANDROID_PRODUCT_OUT}/system/framework" |
Andreas Gampe | 50be66f | 2015-12-28 14:31:06 -0800 | [diff] [blame] | 521 | bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar" |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 522 | run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 523 | else |
| 524 | true # defaults to using target BOOTCLASSPATH |
| 525 | fi |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 526 | elif [ "$runtime" = "art" ]; then |
| 527 | if [ "$target_mode" = "no" ]; then |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 528 | guess_host_arch_name |
Richard Uhler | bb00f81 | 2017-02-16 14:21:10 +0000 | [diff] [blame] | 529 | run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${multi_image_suffix}.art" |
Colin Cross | afd3c9e | 2016-09-16 13:47:21 -0700 | [diff] [blame] | 530 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 531 | else |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 532 | guess_target_arch_name |
Dimitry Ivanov | 49c2c92 | 2017-02-14 11:06:14 -0800 | [diff] [blame] | 533 | run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}" |
Richard Uhler | bb00f81 | 2017-02-16 14:21:10 +0000 | [diff] [blame] | 534 | run_args="${run_args} --boot /data/art-test/core${image_suffix}${multi_image_suffix}.art" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 535 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 536 | if [ "$relocate" = "yes" ]; then |
| 537 | run_args="${run_args} --relocate" |
| 538 | else |
| 539 | run_args="${run_args} --no-relocate" |
| 540 | fi |
Andreas Gampe | 3f1dc56 | 2015-05-18 15:52:22 -0700 | [diff] [blame] | 541 | elif [ "$runtime" = "jvm" ]; then |
| 542 | # TODO: Detect whether the host is 32-bit or 64-bit. |
Alex Light | fba89fe | 2017-01-12 16:11:02 -0800 | [diff] [blame] | 543 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 544 | fi |
| 545 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 546 | if [ "$have_image" = "no" ]; then |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 547 | if [ "$runtime" != "art" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 548 | err_echo "--no-image is only supported on the art runtime" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 549 | exit 1 |
| 550 | fi |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 551 | run_args="${run_args} --no-image" |
| 552 | fi |
| 553 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 554 | if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 555 | err_echo "--dev and --update are mutually exclusive" |
| 556 | usage="yes" |
| 557 | fi |
| 558 | |
| 559 | if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then |
| 560 | err_echo "--dev and --quiet are mutually exclusive" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 561 | usage="yes" |
| 562 | fi |
| 563 | |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 564 | if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then |
| 565 | err_echo "--bisection-search and --prebuild are mutually exclusive" |
| 566 | usage="yes" |
| 567 | fi |
| 568 | |
| 569 | if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then |
| 570 | err_echo "--bisection-search and --no-dex2oat are mutually exclusive" |
| 571 | usage="yes" |
| 572 | fi |
| 573 | |
| 574 | if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then |
| 575 | err_echo "--bisection-search and --no-patchoat are mutually exclusive" |
| 576 | usage="yes" |
| 577 | fi |
| 578 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 579 | if [ "$usage" = "no" ]; then |
| 580 | if [ "x$1" = "x" -o "x$1" = "x-" ]; then |
| 581 | test_dir=`basename "$oldwd"` |
| 582 | else |
| 583 | test_dir="$1" |
| 584 | fi |
| 585 | |
| 586 | if [ '!' -d "$test_dir" ]; then |
| 587 | td2=`echo ${test_dir}-*` |
| 588 | if [ '!' -d "$td2" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 589 | err_echo "${test_dir}: no such test directory" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 590 | usage="yes" |
| 591 | fi |
| 592 | test_dir="$td2" |
| 593 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 594 | # Shift to get rid of the test name argument. The rest of the arguments |
| 595 | # will get passed to the test run. |
| 596 | shift |
| 597 | fi |
| 598 | |
Søren Gjesse | 620d0a5 | 2016-09-19 11:12:51 +0200 | [diff] [blame] | 599 | # For building with javac and dx always use Java 7. The dx compiler |
| 600 | # only support byte codes from Java 7 or earlier (class file major |
| 601 | # version 51 or lower). |
| 602 | if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then |
| 603 | export JAVAC="${JAVAC} -source 1.7 -target 1.7" |
| 604 | fi |
| 605 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 606 | if [ "$usage" = "yes" ]; then |
| 607 | prog=`basename $prog` |
| 608 | ( |
| 609 | echo "usage:" |
| 610 | echo " $prog --help Print this message." |
| 611 | echo " $prog [options] [test-name] Run test normally." |
| 612 | echo " $prog --dev [options] [test-name] Development mode" \ |
| 613 | "(dumps to stdout)." |
| 614 | echo " $prog --update [options] [test-name] Update mode" \ |
| 615 | "(replaces expected.txt)." |
| 616 | echo ' Omitting the test name or specifying "-" will use the' \ |
| 617 | "current directory." |
| 618 | echo " Runtime Options:" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 619 | echo " -O Run non-debug rather than debug build (off by default)." |
| 620 | echo " -Xcompiler-option Pass an option to the compiler." |
Orion Hodson | e1fb77f | 2017-02-27 13:57:18 +0000 | [diff] [blame] | 621 | echo " --build-option Pass an option to the build script." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 622 | echo " --runtime-option Pass an option to the runtime." |
| 623 | echo " --debug Wait for a debugger to attach." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 624 | echo " --debuggable Whether to compile Java code for a debugger." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 625 | echo " --gdb Run under gdb; incompatible with some tests." |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 626 | echo " --gdb-arg Pass an option to gdb." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 627 | echo " --build-only Build test files only (off by default)." |
Søren Gjesse | 620d0a5 | 2016-09-19 11:12:51 +0200 | [diff] [blame] | 628 | echo " --build-with-javac-dx Build test files with javac and dx (off by default)." |
| 629 | echo " --build-with-jack Build test files with jack and jill (on by default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 630 | echo " --interpreter Enable interpreter only mode (off by default)." |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 631 | echo " --jit Enable jit (off by default)." |
Nicolas Geoffray | 0e07125 | 2015-03-21 13:43:15 +0000 | [diff] [blame] | 632 | echo " --optimizing Enable optimizing compiler (default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 633 | echo " --no-verify Turn off verification (on by default)." |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 634 | echo " --verify-soft-fail Force soft fail verification (off by default)." |
| 635 | echo " Verification is enabled if neither --no-verify" |
| 636 | echo " nor --verify-soft-fail is specified." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 637 | echo " --no-optimize Turn off optimization (on by default)." |
| 638 | echo " --no-precise Turn off precise GC (on by default)." |
| 639 | echo " --zygote Spawn the process from the Zygote." \ |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 640 | "If used, then the" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 641 | echo " other runtime options are ignored." |
| 642 | echo " --no-dex2oat Run as though dex2oat was failing." |
| 643 | echo " --no-patchoat Run as though patchoat was failing." |
| 644 | echo " --prebuild Run dex2oat on the files before starting test. (default)" |
| 645 | echo " --no-prebuild Do not run dex2oat on the files before starting" |
| 646 | echo " the test." |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 647 | echo " --strip-dex Strip the dex files before starting test." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 648 | echo " --relocate Force the use of relocating in the test, making" |
| 649 | echo " the image and oat files be relocated to a random" |
Nicolas Geoffray | 94e25db | 2017-01-27 14:54:28 +0000 | [diff] [blame] | 650 | echo " address before running." |
| 651 | echo " --no-relocate Force the use of no relocating in the test. (default)" |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 652 | echo " --image Run the test using a precompiled boot image. (default)" |
| 653 | echo " --no-image Run the test without a precompiled boot image." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 654 | echo " --host Use the host-mode virtual machine." |
| 655 | echo " --invoke-with Pass --invoke-with option to runtime." |
| 656 | echo " --dalvik Use Dalvik (off by default)." |
| 657 | echo " --jvm Use a host-local RI virtual machine." |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 658 | echo " --use-java-home Use the JAVA_HOME environment variable" |
| 659 | echo " to find the java compiler and runtime" |
| 660 | echo " (if applicable) to run the test with." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 661 | echo " --output-path [path] Location where to store the build" \ |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 662 | "files." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 663 | echo " --64 Run the test in 64-bit mode" |
| 664 | echo " --trace Run with method tracing" |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 665 | echo " --strace Run with syscall tracing from strace." |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 666 | echo " --stream Run method tracing in streaming mode (requires --trace)" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 667 | echo " --gcstress Run with gc stress testing" |
| 668 | echo " --gcverify Run with gc verification" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 669 | echo " --jvmti-trace-stress Run with jvmti method tracing stress testing" |
| 670 | echo " --jvmti-redefine-stress" |
| 671 | echo " Run with jvmti method redefinition stress testing" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 672 | echo " --always-clean Delete the test files even if the test fails." |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 673 | echo " --never-clean Keep the test files even if the test succeeds." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 674 | echo " --android-root [path] The path on target for the android root. (/system by default)." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 675 | echo " --dex2oat-swap Use a dex2oat swap file." |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 676 | echo " --instruction-set-features [string]" |
| 677 | echo " Set instruction-set-features for compilation." |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 678 | echo " --multi-image Use a set of images compiled with dex2oat multi-image for" |
| 679 | echo " the boot class path." |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 680 | echo " --pic-test Compile the test code position independent." |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 681 | echo " --quiet Don't print anything except failure messages" |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 682 | echo " --bisection-search Perform bisection bug search." |
Nicolas Geoffray | b0bbe8e | 2016-11-19 10:42:37 +0000 | [diff] [blame] | 683 | echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild." |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 684 | echo " --suspend-timeout Change thread suspend timeout ms (default 500000)." |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 685 | ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set. |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 686 | exit 1 |
| 687 | fi |
| 688 | |
| 689 | cd "$test_dir" |
| 690 | test_dir=`pwd` |
| 691 | |
| 692 | td_info="${test_dir}/${info}" |
| 693 | td_expected="${test_dir}/${expected}" |
| 694 | |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 695 | if [ ! -r $td_info ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 696 | err_echo "${test_dir}: missing file $td_info" |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 697 | exit 1 |
| 698 | fi |
| 699 | |
| 700 | if [ ! -r $td_expected ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 701 | err_echo "${test_dir}: missing file $td_expected" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 702 | exit 1 |
| 703 | fi |
| 704 | |
| 705 | # copy the test to a temp dir and run it |
| 706 | |
Elliott Hughes | 510c878 | 2011-10-06 10:57:34 -0700 | [diff] [blame] | 707 | echo "${test_dir}: building..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 708 | |
| 709 | rm -rf "$tmp_dir" |
| 710 | cp -Rp "$test_dir" "$tmp_dir" |
| 711 | cd "$tmp_dir" |
| 712 | |
| 713 | if [ '!' -r "$build" ]; then |
| 714 | cp "${progdir}/etc/default-build" build |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 715 | else |
| 716 | cp "${progdir}/etc/default-build" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 717 | fi |
| 718 | |
| 719 | if [ '!' -r "$run" ]; then |
| 720 | cp "${progdir}/etc/default-run" run |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 721 | else |
| 722 | cp "${progdir}/etc/default-run" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 723 | fi |
| 724 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 725 | if [ '!' -r "$check_cmd" ]; then |
| 726 | cp "${progdir}/etc/default-check" check |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 727 | else |
| 728 | cp "${progdir}/etc/default-check" . |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 729 | fi |
| 730 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 731 | chmod 755 "$build" |
| 732 | chmod 755 "$run" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 733 | chmod 755 "$check_cmd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 734 | |
Elliott Hughes | 8cbc8bc | 2011-10-04 11:19:45 -0700 | [diff] [blame] | 735 | export TEST_NAME=`basename ${test_dir}` |
| 736 | |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 737 | # Tests named '<number>-checker-*' will also have their CFGs verified with |
| 738 | # Checker when compiled with Optimizing on host. |
| 739 | if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then |
Nicolas Geoffray | b76bc78 | 2016-09-14 12:33:34 +0000 | [diff] [blame] | 740 | if [ "$runtime" = "art" -a "$image_suffix" = "" -a "$USE_JACK" = "true" ]; then |
Nicolas Geoffray | f654ef9 | 2017-06-09 16:31:21 +0100 | [diff] [blame] | 741 | # In no-prebuild or no-image mode, the compiler only quickens so disable the checker. |
| 742 | if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 743 | run_checker="yes" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 744 | |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 745 | if [ "$target_mode" = "no" ]; then |
| 746 | cfg_output_dir="$tmp_dir" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 747 | checker_args="--arch=${host_arch_name^^}" |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 748 | else |
| 749 | cfg_output_dir="$DEX_LOCATION" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 750 | checker_args="--arch=${target_arch_name^^}" |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 751 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 752 | |
| 753 | if [ "$debuggable" = "yes" ]; then |
| 754 | checker_args="$checker_args --debuggable" |
| 755 | fi |
| 756 | |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 757 | run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \ |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 758 | -Xcompiler-option -j1" |
| 759 | fi |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 760 | fi |
| 761 | fi |
| 762 | |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 763 | run_args="${run_args} --testlib ${testlib}" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 764 | |
Richard Uhler | 020c0f3 | 2017-03-14 16:23:17 +0000 | [diff] [blame] | 765 | # To cause tests to fail fast, limit the file sizes created by dx, dex2oat and |
| 766 | # ART output to approximately 128MB. This should be more than sufficient |
| 767 | # for any test while still catching cases of runaway output. |
| 768 | # Set a hard limit to encourage ART developers to increase the ulimit here if |
| 769 | # needed to support a test case rather than resetting the limit in the run |
| 770 | # script for the particular test in question. |
Orion Hodson | bd328d3 | 2017-03-24 11:24:10 +0000 | [diff] [blame] | 771 | if ! ulimit -f 128000; then |
Richard Uhler | 020c0f3 | 2017-03-14 16:23:17 +0000 | [diff] [blame] | 772 | err_echo "ulimit file size setting failed" |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 773 | fi |
| 774 | |
Igor Murashkin | 2a33775 | 2017-06-16 14:34:40 +0000 | [diff] [blame^] | 775 | if [[ "$target_mode" == "yes" ]]; then |
| 776 | build_args="$build_args --target" |
| 777 | else |
| 778 | build_args="$build_args --host" |
| 779 | fi |
| 780 | |
| 781 | if [[ "$dev_mode" == "yes" ]]; then |
| 782 | build_args="$build_args --dev" |
| 783 | fi |
| 784 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 785 | good="no" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 786 | good_build="yes" |
| 787 | good_run="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 788 | if [ "$dev_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 789 | "./${build}" $build_args 2>&1 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 790 | build_exit="$?" |
| 791 | echo "build exit status: $build_exit" 1>&2 |
| 792 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 793 | echo "${test_dir}: running..." 1>&2 |
| 794 | "./${run}" $run_args "$@" 2>&1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 795 | run_exit="$?" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 796 | |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 797 | if [ "$run_exit" = "0" ]; then |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 798 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 799 | if [ "$target_mode" = "yes" ]; then |
| 800 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 801 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 802 | "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1 |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 803 | checker_exit="$?" |
| 804 | if [ "$checker_exit" = "0" ]; then |
| 805 | good="yes" |
| 806 | fi |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 807 | err_echo "checker exit status: $checker_exit" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 808 | else |
| 809 | good="yes" |
| 810 | fi |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 811 | fi |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 812 | echo "run exit status: $run_exit" 1>&2 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 813 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 814 | elif [ "$update_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 815 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 816 | build_exit="$?" |
| 817 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 818 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 819 | "./${run}" $run_args "$@" >"$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 820 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 821 | if [ "$target_mode" = "yes" ]; then |
| 822 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 823 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 824 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 825 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 826 | sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}" |
| 827 | good="yes" |
| 828 | else |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 829 | cat "$build_output" 1>&${real_stderr} 1>&2 |
| 830 | err_echo "build exit status: $build_exit" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 831 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 832 | elif [ "$build_only" = "yes" ]; then |
| 833 | good="yes" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 834 | "./${build}" $build_args >"$build_output" 2>&1 |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 835 | build_exit="$?" |
| 836 | if [ "$build_exit" '!=' '0' ]; then |
| 837 | cp "$build_output" "$output" |
| 838 | echo "build exit status: $build_exit" >>"$output" |
| 839 | diff --strip-trailing-cr -q "$expected" "$output" >/dev/null |
| 840 | if [ "$?" '!=' "0" ]; then |
| 841 | good="no" |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 842 | err_echo "BUILD FAILED For ${TEST_NAME}" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 843 | fi |
| 844 | fi |
Tsu Chiang Chuang | 379e2f5 | 2013-08-20 12:24:52 -0700 | [diff] [blame] | 845 | # Clean up extraneous files that are not used by tests. |
Tsu Chiang Chuang | 0160d99 | 2013-09-13 14:17:42 -0700 | [diff] [blame] | 846 | find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 847 | exit 0 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 848 | else |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 849 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 850 | build_exit="$?" |
| 851 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 852 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 853 | "./${run}" $run_args "$@" >"$output" 2>&1 |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 854 | run_exit="$?" |
| 855 | if [ "$run_exit" != "0" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 856 | err_echo "run exit status: $run_exit" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 857 | good_run="no" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 858 | elif [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 859 | if [ "$target_mode" = "yes" ]; then |
| 860 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 861 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 862 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 863 | checker_exit="$?" |
| 864 | if [ "$checker_exit" != "0" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 865 | err_echo "checker exit status: $checker_exit" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 866 | good_run="no" |
| 867 | else |
| 868 | good_run="yes" |
| 869 | fi |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 870 | else |
| 871 | good_run="yes" |
| 872 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 873 | else |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 874 | good_build="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 875 | cp "$build_output" "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 876 | echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output" |
| 877 | echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output" |
Ian Rogers | d9ad27d | 2014-10-27 13:48:21 -0700 | [diff] [blame] | 878 | echo "Args: ${args}" >> "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 879 | echo "build exit status: $build_exit" >> "$output" |
Andreas Gampe | 5c11490 | 2014-10-27 17:03:58 -0700 | [diff] [blame] | 880 | max_name_length=$(getconf NAME_MAX ${tmp_dir}) |
| 881 | echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output" |
| 882 | max_path_length=$(getconf PATH_MAX ${tmp_dir}) |
Andreas Gampe | 602fbcd | 2014-10-27 17:06:29 -0700 | [diff] [blame] | 883 | echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 884 | fi |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 885 | ./$check_cmd "$expected" "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 886 | if [ "$?" = "0" ]; then |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 887 | if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then |
| 888 | # output == expected |
| 889 | good="yes" |
| 890 | echo "${test_dir}: succeeded!" 1>&2 |
| 891 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 892 | fi |
| 893 | fi |
| 894 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 895 | ( |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 896 | if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 897 | echo "${test_dir}: FAILED!" |
| 898 | echo ' ' |
| 899 | echo '#################### info' |
| 900 | cat "${td_info}" | sed 's/^/# /g' |
| 901 | echo '#################### diffs' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 902 | diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 903 | echo '####################' |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 904 | if [ "$strace" = "yes" ]; then |
| 905 | echo '#################### strace output' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 906 | tail -n 3000 "$tmp_dir/$strace_output" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 907 | echo '####################' |
| 908 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 909 | echo ' ' |
| 910 | fi |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 911 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 912 | ) 2>&${real_stderr} 1>&2 |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 913 | |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 914 | # Attempt bisection only if the test failed. |
| 915 | if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then |
| 916 | # Bisecting works by skipping different optimization passes which breaks checker assertions. |
| 917 | if [ "$run_checker" == "yes" ]; then |
| 918 | echo "${test_dir}: not bisecting, checker test." 1>&2 |
| 919 | else |
| 920 | # Increase file size limit, bisection search can generate large logfiles. |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 921 | echo "${test_dir}: bisecting..." 1>&2 |
| 922 | cwd=`pwd` |
| 923 | maybe_device_mode="" |
| 924 | raw_cmd="" |
| 925 | if [ "$target_mode" = "yes" ]; then |
| 926 | # Produce cmdline.sh in $DEX_LOCATION. "$@" is passed as a runtime option |
| 927 | # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set |
| 928 | # to exec in order to preserve pid when calling dalvikvm. This is required |
| 929 | # for bisection search to correctly retrieve logs from device. |
| 930 | "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null |
| 931 | adb shell chmod u+x "$DEX_LOCATION/cmdline.sh" |
| 932 | maybe_device_mode="--device" |
| 933 | raw_cmd="$DEX_LOCATION/cmdline.sh" |
| 934 | else |
| 935 | raw_cmd="$cwd/${run} --external-log-tags $run_args $@" |
| 936 | fi |
| 937 | $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \ |
| 938 | $maybe_device_mode \ |
| 939 | --raw-cmd="$raw_cmd" \ |
| 940 | --check-script="$cwd/check" \ |
| 941 | --expected-output="$cwd/expected.txt" \ |
Wojciech Staszkiewicz | 0c88383 | 2016-09-26 17:51:52 -0700 | [diff] [blame] | 942 | --logfile="$cwd/bisection_log.txt" \ |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 943 | --timeout=300 |
| 944 | fi |
| 945 | fi |
| 946 | |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 947 | # Clean up test files. |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 948 | if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 949 | cd "$oldwd" |
| 950 | rm -rf "$tmp_dir" |
| 951 | if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then |
| 952 | adb shell rm -rf $DEX_LOCATION |
| 953 | fi |
| 954 | if [ "$good" = "yes" ]; then |
| 955 | exit 0 |
| 956 | fi |
| 957 | fi |
| 958 | |
| 959 | |
| 960 | ( |
| 961 | if [ "$always_clean" = "yes" ]; then |
| 962 | echo "${TEST_NAME} files deleted from host " |
| 963 | if [ "$target_mode" == "yes" ]; then |
| 964 | echo "and from target" |
| 965 | fi |
| 966 | else |
| 967 | echo "${TEST_NAME} files left in ${tmp_dir} on host" |
| 968 | if [ "$target_mode" == "yes" ]; then |
| 969 | echo "and in ${DEX_LOCATION} on target" |
| 970 | fi |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 971 | fi |
| 972 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 973 | ) 2>&${real_stderr} 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 974 | |
Alex Light | 6a870fa | 2016-05-31 16:36:19 -0700 | [diff] [blame] | 975 | if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then |
| 976 | exit 0 |
| 977 | else |
| 978 | exit 1 |
| 979 | fi |